#include <stdio.h>
#include <string.h>

/** hanterm xf3.2p2 hangul.c ִ  table */
#include "ks_table.h"
/**/

/* ¹ȣ */
#define ENG     0
#define ETK     1
#define KTE     2

/*    */
#define JA      1
#define MO      2

/* ,,  ִ  */
#define FE      1
#define ME      2
#define LE      1

/** hanterm xf3.2p2 hangul.c ִ macro */
#define han_index(h, l) (((h)-0xb0)*(0xff-0xa1)+((l)-0xa1))
/**/

/* ѱ  macro */
#define printhan(f,m,l) convert_3_to_ks((f),(m),(l),d);         \
                        if(johab){                              \
                                strcpy(d2,d);                   \
                                convert_ks_to_johab(d2,d,2);    \
                        }                                       \
                        printf("%c%c",d[0],d[1])
/* ʼȣ ã */
#define frev(f)         ((f)==FE ? ' ':ja[(f)-FE-1])
/* ߼ȣ ã */
#define mrev(m)         ((m)==ME ? ' ':M[(m)-ME-1])
/* ȣ ã */
#define lrev(l)         ((l)==LE ? ' ':L[(l)-LE-1])

#define isalpha(a)	(((a)>='a'&&(a)<='z')||((a)>='A'&&(a)<='Z') ? 1:0)

/* ѱ ǿ شϴ alphbet */
int ja[19] =
{'r', 'R', 's', 'e', 'E', 'f', 'a', 'q', 'Q', 't', 'T', 'd', 'w', 'W', 'c', 'z', 'x', 'v', 'g'};
int mo[14] =
{'k', 'o', 'i', 'O', 'j', 'p', 'u', 'P', 'h', 'y', 'n', 'b', 'm', 'l'};

/* (߼) ()   table */
int M[27] =
{'k', 'o', 'i', 'O', 'j', '?', '?', 'p', 'u', 'P', 'h', '?', '?', '?', '?', '?', 'y', 'n', '?', '?', '?', '?', '?', 'b', 'm', '?', 'l'};
int L[29] =
{'r', 'R', '?', 's', '?', '?', 'e', 'f', '?', '?', '?', '?', '?', '?', '?', 'a', '?', 'q', '?', 't', 'T', 'd', 'w', 'c', '?', 'x', 'v', 'g'};

/** hanterm xf3.2p2 hangul.c ִ Լ */

/*
   Hangul routines

   written by Song Jaekyung
 */

int (*convert_3_to_code) (int f, int m, int l, unsigned char *des);

/* ϼ ڵ带    ٲ۴.
 */

void
convert_ks_to_3 (unsigned char *src, int *f, int *m, int *l)
{
  int h = *src;
  int low = *(src + 1);
  int c;
  int i;

  if ((i = han_index (h, low)) >= 0 && i < sizeof (ks_table1) / sizeof (ks_table1[0]))
    {
      *f = ks_table1[i][0];
      *m = ks_table1[i][1];
      *l = ks_table1[i][2];
    }
  else
    {
      c = (h << 8) | low;
      for (i = 0; i < 40; i++)
	if (ks_table2[i][0] == c)
	  {
	    *f = ks_table2[i][1];
	    *m = ks_table2[i][2];
	    *l = ks_table2[i][3];
	    return;
	  }
      *f = 0xff;		/* ׷ ڵ */
      *m = h;
      *l = low;
    }
}

/*    ڵ带 ϼ ڵ ٲ۴.
   f : ʼ (1 = (ä), 2 = , 3 = , 4 = , 5 = , 6 = , 7 = , ...
   m : ߼ (2 = (ä), 3 = , 4 = , 5 = , 6 = , 7 = , 8 = *, ...
   l :  (1 = (ä), 2 = , 3 = , 4 = , 5 = , 6 = , ...
   des : ϼ ڵ
   ϼ ڵ忡  쿡   8 byte   ش.
   (ä) (ʼ) (߼) ()
   (ä) = 0xA4D4
   (ʼ) = 0xA4A1 - 0xA4FE
   (ʼ) = 0xA4A1 - 0xA4FE
   (ʼ) = 0xA4A1 - 0xA4FE
    : des  ־ byte , 2 | 8
 */
int
convert_3_to_ks (f, m, l, des)
     int f, m, l;
     unsigned char *des;
{
  unsigned char key[3];
  register int hi, lo, mi, result, found;

  if (f == 0xff)
    {
      des[0] = m;
      des[1] = l;
      return 2;
    }
  key[0] = f;
  key[1] = m;
  key[2] = l;
  lo = 0;
  hi = sizeof (ks_table1) / 3 - 1;
  found = 0;
  while (lo + 1 < hi)
    {
      mi = (lo + hi) / 2;
      result = strncmp ((char *) ks_table1[mi], (char *) key, 3);
      if (result == 0)
	{
	  found = 1;
	  break;
	}
      else if (result > 0)
	{
	  hi = mi;
	}
      else
	{
	  lo = mi;
	}
    }
  if (!found)
    {
      if (!strncmp ((char *) ks_table1[lo], (char *) key, 3))
	{
	  found = 1;
	  mi = lo;
	}
      if (!strncmp ((char *) ks_table1[hi], (char *) key, 3))
	{
	  found = 1;
	  mi = hi;
	}
    }
  if (!found)
    {
      for (mi = 0; mi < 40; mi++)
	if (ks_table2[mi][1] == f && ks_table2[mi][2] == m &&
	    ks_table2[mi][3] == l)
	  {
	    des[0] = ks_table2[mi][0] >> 8;
	    des[1] = ks_table2[mi][0];
	    return 2;		/* found */
	  }
    }
  else
    {
      des[0] = mi / (0xff - 0xa1) + 0xb0;
      des[1] = mi % (0xff - 0xa1) + 0xa1;
      return 2;			/* found */
    }

  /* ϼ ǥ . ``KS C 5601 - 1992  ȯ ȣ ؼ''
     3.3    encoding Ѵ. */

  *des++ = 0xa4;		/* ä */
  *des++ = 0xd4;
  *des++ = 0xa4;		/* ڴ  a4 ࿡ ִ. */
  *des++ = johab_fcon_to_wan[f];
  *des++ = 0xa4;
  *des++ = johab_vow_to_wan[m];
  *des++ = 0xa4;
  *des++ = johab_lcon_to_wan[l];
  return 8;
}

/* 3 Ʈ   -> 2 Ʈ  */

int
convert_3_to_johab (f, m, l, buf)
     int f, m, l;
     unsigned char *buf;
{
  if (f == 0xff)
    {
      if (m >= 0xa1 && m <= 0xac)
	{
	  buf[0] = (m - 0xa1) / 2 + 0xd9;
	  if (m & 1)
	    {			/* 0xa1, 0xa3, 0xa5, ... */
	      buf[1] = (l - 0xa1 < 0x7f - 0x31) ? l - 0xa1 + 0x31 : l - 0xa1 + 0x91 - 0x7f + 0x31;	/* bug ! */
	    }
	  else
	    {
	      buf[1] = l;
	    }
	}
      else if (m >= 0xad && m <= 0xaf)
	{			/*  ȵ  */
	  buf[0] = 0xd9;	/* ڷ ä */
	  buf[1] = 0x31;
	}
      else if (m == 0xc9 || m == 0xfe)
	{
	  buf[0] = 0xd8;
	  if (m & 1)
	    {
	      buf[1] = (l - 0xa1 < 0x7f - 0x31) ? l - 0xa1 + 0x31 : l - 0xa1 + 0x91;
	    }
	  else
	    {
	      buf[1] = l;
	    }
	}
      else if (m > 0xc9 && m < 0xfe)
	{
	  buf[0] = (m - 0xca) / 2 + 0xe0;
	  if (m & 1)
	    {
	      buf[1] = l;
	    }
	  else
	    {
	      buf[1] = (l - 0xa1 < 0x7f - 0x31) ? l - 0xa1 + 0x31 : l - 0xa1 + 0x91 - 0x7f + 0x31;	/* bug ! */
	    }
	}
    }
  else
    {
      buf[0] = 0x80 | (f << 2) | (m >> 3);
      buf[1] = (m << 5) | l;
    }
  return 2;
}

/*  ڸ 3 Ʈ  ٲ۴. */

void
convert_johab_to_3 (src, f, m, l)
     unsigned char *src;
     int *f, *m, *l;
{
  if (src[0] >= 0x84 && src[0] <= 0xd3)
    {				/*  ѱ */
      *f = (src[0] >> 2) & 0x1f;
      *m = ((src[0] << 3) | (src[1] >> 5)) & 0x1f;
      *l = src[1] & 0x1f;
    }
  else
    {				/* Ư  */
      *f = 0xff;
      if (src[0] >= 0xd9 && src[0] <= 0xde)
	{			/* ɹ */
	  *m = (src[0] - 0xd9) * 2 + 0xa1;
	}
      else if (src[0] >= 0xe0 && src[0] <= 0xf9)
	{			/*  */
	  *m = (src[0] - 0xe0) * 2 + 0xca;	/* good */
	}
      else if (src[0] == 0xd8)
	{
	  *m = 0xc9;
	}
      if (src[1] >= 0x31 && src[1] <= 0x7e)
	{
	  *l = src[1] - 0x31 + 0xa1;
	}
      else if (src[1] >= 0x91 && src[1] <= 0xa0)
	{
	  *l = src[1] - 0x91 + (0x7f - 0x31) + 0xa1;
	}
      else if (src[1] >= 0xa1 && src[1] <= 0xfe)
	{
	  *l = src[1];
	  if (src[0] == 0xd8)
	    {
	      *m = 0xfe;
	    }
	  else
	    {
	      (*m)++;
	    }
	}
      else
	{
	  *l = 0;
	}
    }
}

/* ϼ ڿ 2 Ʈ  ڿ ٲ۴.
    ڿ ̸ ش. 
    ϼؼ  
   src  des  迭̾  */

int
convert_ks_to_johab (src, des, n)
     unsigned char *src, *des;
     int n;
{
  unsigned char *orgdes = des;
  int f, m, l;

  while (n > 0)
    {
      if (*src & 0x80)
	{
	  convert_ks_to_3 (src, &f, &m, &l);
	  convert_3_to_johab (f, m, l, des);
	  src += 2;
	  des += 2;
	  n -= 2;
	}
      else
	{
	  *des++ = *src++;
	  n--;
	}
    }
  return (des - orgdes);
}

/*  ڿ ϼ ڿ ٲ۴. ȯ ϼ ڿ ̸
   ش. */

int
convert_johab_to_ks (src, des, len)
     unsigned char *src, *des;
     int len;
{
  int f, m, l;
  unsigned char *org_des;

  org_des = des;
  while (len > 0)
    {
      if (*src & 0x80)
	{
	  convert_johab_to_3 (src, &f, &m, &l);
	  des += convert_3_to_ks (f, m, l, des);
	  src += 2;
	  len -= 2;
	}
      else
	{
	  *des++ = *src++;
	  --len;
	}
    }
  return des - org_des;
}
/**/

/* ʼȣ ã */
int
fcode (f)
     int f;
{
  int i;

  for (i = 0; i < 19; i++)
    if (f == ja[i])
      return (i + 2);
  return (FE);
}

/* ߼ȣ ã */
int
mcode (m)
     int m;
{

  int i;

  for (i = 0; i < 27; i++)
    if (m == M[i])
      return (i + 3);
  return (ME);
}

/* ȣ ã */
int
lcode (f, m, l)
     int f, m, l;
{

  int i, k;

  for (i = 0; i < 29; i++)
    if (l == L[i])
      k = i + 2;

  /* check last */
  for (i = 0; i < sizeof (ks_table1) / 3; i++)
    if (ks_table1[i][0] == f && ks_table1[i][1] == m && ks_table1[i][2] == k)
      return (k);

  return (LE);
}

/* (߼)ȣ ã */
int
mmcode (m, mm)
     int m, mm;
{
  switch (m)
    {
    case 13:
      switch (mm)
	{
	case 'k':
	  return (14);
	case 'o':
	  return (15);
	case 'l':
	  return (18);
	}
      break;
    case 20:
      switch (mm)
	{
	case 'j':
	  return (21);
	case 'p':
	  return (22);
	case 'l':
	  return (23);
	}
      break;
    case 27:
      if (mm == 'l')
	return (28);
      break;
    }
  return (ME);
}

/* ()ȣ ã */
int
llcode (f, m, l, ll)
     int f, m, l, ll;
{
  int i, k;

  switch (l)
    {
    case 2:
      if (ll == 't')
	k = 4;
      break;
    case 5:
      if (ll == 'w')
	k = 6;
      else if (ll == 'g')
	k = 7;
      break;
    case 9:
      if (ll == 'r')
	k = 10;
      else if (ll == 'a')
	k = 11;
      else if (ll == 'q')
	k = 12;
      else if (ll == 't')
	k = 13;
      else if (ll == 'x')
	k = 14;
      else if (ll == 'v')
	k = 15;
      else if (ll == 'g')
	k = 16;
      break;
    case 19:
      if (ll == 't')
	k = 20;
      break;
    }

  /* ,, ռ Ȯ */
  for (i = 0; i < sizeof (ks_table1) / 3; i++)
    if (ks_table1[i][0] == f && ks_table1[i][1] == m && ks_table1[i][2] == k)
      return (k);

  return (LE);
}

/* ,  Ǻ */
int
jamo (jamo)
     int jamo;
{
  int i;

  if (jamo == 'J' || jamo == 'K' || jamo == 'L')
    return (MO);
  for (i = 0; i < 19; i++)
    if (jamo == ja[i])
      return (JA);
  for (i = 0; i < 14; i++)
    if (jamo == mo[i])
      return (MO);
  return (0);
}

/* ʼ   */
void
prtf (f)
     int f;
{
  if (f != FE)
    printf ("%c", frev (f));
}

/* ߼   */
void
prtm (m)
     int m;
{
  if (m != ME)
    switch (m)
      {
      case 14:
	printf ("hk");
	break;
      case 15:
	printf ("ho");
	break;
      case 18:
	printf ("hl");
	break;
      case 21:
	printf ("nj");
	break;
      case 22:
	printf ("np");
	break;
      case 23:
	printf ("nl");
	break;
      case 28:
	printf ("ml");
	break;
      default:
	printf ("%c", mrev (m));
	break;
      }
}

/*    */
void
prtl (l)
     int l;
{
  if (l != LE)
    switch (l)
      {
      case 4:
	printf ("rt");
	break;
      case 6:
	printf ("sw");
	break;
      case 7:
	printf ("sg");
	break;
      case 10:
	printf ("fr");
	break;
      case 11:
	printf ("fa");
	break;
      case 12:
	printf ("fq");
	break;
      case 13:
	printf ("ft");
	break;
      case 14:
	printf ("fx");
	break;
      case 15:
	printf ("fv");
	break;
      case 16:
	printf ("fg");
	break;
      case 20:
	printf ("qt");
	break;
      default:
	printf ("%c", lrev (l));
	break;
      }
}

int
main (argc, argv)
     int argc;
     char **argv;
{
  int i;			/* for  */
  int johab = 0, et = ENG, bi = 0, vet = 0;	/* johab: 0:    ϼ  
						 *        1:     
						 * et:  ENG:    Է
						 *      ETK:    ѱ(et)Է
						 *      KTE: (et)Է
						 * bi:          et  Ǻ 
						 * vet:         et  ¿ 
						 */
  int delimiter = 1, text = 0;	/* delimiter:   纯ȯ   
				 * text:      Ϲ  ȯ */
  int f, m, mm, l, ll, ltmp, tmp;	/* f,m,mm,l,ll: ,,,,ȣ
					 * ltmp:         ι° , ӽú
					 * tmp:          Է¹, ӽú
					 */
  unsigned char d[2], d2[2];	/* d:           ѱ۹ȣ
				 * d2:           ȯ 
				 */
  /* Էµ ڸ ȯ ϹǷ alphabet ڿ   */
  static char begin[] = "\\{";	/* et  */
  char verb = '\'';		/* et  ½ : ,Ŀ  */
  char end = '}';		/* et  */
  static char rbegin[] = "\\}";	/* rev  */
  char rend = '{';		/* rev  */

  /*  ½ file̸ et2jh */
  if (!strcmp (argv[0], "et2jh"))
    johab = 1;

  /* option  */
  for (i = 1; i < argc; i++)
    if (!strcmp (argv[i], "--help") || !strcmp (argv[i], "-h"))
      {
	printf ("Usage: et2kc [OPTIONS] [< infile] [> outfile]\n");
	printf ("       Convert english type into korean code.\n\n");
	printf ("                     can handle only stdin and stdout\n");
	printf ("  -e, --et2kc        convert english type into korean\n");
	printf ("  -r, --reverse      convert korean into english type\n");
	printf ("      --kc2et\n");
	printf ("  -n, --nodelimiter  do not print delimiter for reconversion\n");
	printf ("  -t, --text         convert text into et\n");
	printf ("  -o, --other        use other code to print korean\n");
	printf ("                     et2kc: KSC code by default\n");
	printf ("                            Combination code with --other\n");
	printf ("                     et2jh: Combination code by default\n");
	printf ("                            KSC code with --other\n");
	printf ("  -k, --ksc          use KSC code to print korean\n");
	printf ("  -j, --johab        use Combination code to print korean\n");
	printf ("                     ignore --other\n");
	printf ("  -h, --help         display this help and exit\n");
	printf ("  -v, --version      display version and exit\n\n");
	exit (0);
      }
    else if (!strcmp (argv[i], "-e") || !strcmp (argv[i], "--et2kc"))
      et = ETK;
    else if (!strcmp (argv[i], "-r") || !strcmp (argv[i], "--reverse") || !strcmp (argv[i], "--kc2et"))
      et = KTE;
    else if (!strcmp (argv[i], "-n") || !strcmp (argv[i], "--nodelimiter"))
      delimiter = 0;
    else if (!strcmp (argv[i], "-t") || !strcmp (argv[i], "--text"))
      text = 1;
    else if (!strcmp (argv[i], "-o") || !strcmp (argv[i], "--other"))
      {
	if (johab)
	  johab = 0;
	else
	  johab = 1;
      }
    else if (!strcmp (argv[i], "-k") || !strcmp (argv[i], "--ksc"))
      johab = 0;
    else if (!strcmp (argv[i], "-j") || !strcmp (argv[i], "--johab"))
      johab = 1;
    else if (!strcmp (argv[i], "-v") || !strcmp (argv[i], "--version"))
      {
	printf ("et2kc \\{tlwkrgkrl} 0.1\n");
	exit (0);
      }
  /* Ҹȣ  */
  f = FE;
  m = ME;
  l = LE;
  ll = LE;

  /* ù ޱ */
  tmp = getchar ();
  if (text)
    et = KTE;

  /* file  а ϱ */
  while (tmp != EOF)
    {
      bi = 0;
      vet = 0;
      if (!text)
	{
	  /* et  ϱ? */
	  if (tmp == verb)
	    {
	      /*   ϸ  ڴ   */
	      if (f != FE || m != ME || l != LE || ll != LE)
		{
		  printhan (f, m, (ll == LE ? l : ll));
		  f = FE;
		  m = ME;
		  l = LE;
		  ll = LE;
		}
	      while ((tmp = getchar ()) == verb)
		printf ("%c", verb);
	      vet = 1;
	    }
	}
      /* et ϱ? */
      while (tmp == begin[bi++])
	tmp = getchar ();
      if (bi == strlen (begin) + 1)
	{
	  if (text)
	    {
	      printf ("%c", verb);
	      printf ("%s", begin);
	      printf ("%c", verb);
	    }
	  else
	    {
	      if (vet)
		{
		  if (tmp == verb)
		    {		/* et   */
		      if (delimiter)
			printf ("%c", verb);
		      printf ("%s", begin);
		      if (delimiter)
			printf ("%c", verb);
		      tmp = getchar ();
		    }
		  else
		    {
		      printf ("%c", verb);
		      if (delimiter)
			printf ("%s", rbegin);
		      et = ETK;
		    }
		}
	      else
		{
		  if (delimiter)
		    printf ("%s", rbegin);
		  et = ETK;
		}
	    }
	  if (tmp == begin[0] || tmp == rbegin[0])
	    continue;
	}
      else
	{
	  bi--;
	  while (tmp == rbegin[bi++])
	    tmp = getchar ();
	  if (bi == strlen (rbegin) + 1)
	    {
	      if (text)
		{
		  printf ("%c", verb);
		  printf ("%s", rbegin);
		  printf ("%c", verb);
		}
	      else
		{
		  if (vet)
		    {
		      if (tmp == verb)
			{	/* rev   */
			  if (delimiter)
			    printf ("%c", verb);
			  printf ("%s", rbegin);
			  if (delimiter)
			    printf ("%c", verb);
			  tmp = getchar ();
			}
		      else
			{
			  printf ("%c", verb);
			  if (delimiter)
			    printf ("%s", begin);
			  et = KTE;
			}
		    }
		  else
		    {
		      if (delimiter)
			printf ("%s", begin);
		      et = KTE;
		    }
		}
	      if (tmp == begin[0] || tmp == rbegin[0])	/*  ϸ ? */
		continue;
	    }
	  else
	    {
	      if (vet)
		printf ("%c", verb);
	      for (i = 1; i < bi; i++)
		printf ("%c", rbegin[i - 1]);
	      if ((!text && tmp == verb) || ((tmp == begin[0] || tmp == rbegin[0]) && !(bi % 2)))	/* Ȧ¦  ǰ */
		continue;
	    }
	}
      /* while loop getchar() EOF  */
      if (tmp == EOF)
	break;
      /* et  */
      switch (et)
	{
	case ETK:
	  switch (jamo (tmp))
	    {
	    case JA:		/*  */
	      if (f == FE)
		{
		  if (m != ME)
		    {
		      printhan (f, m, (ll == LE ? l : ll));
		      m = ME;
		      l = LE;
		      ll = LE;
		    }
		  /* ->ʼ */
		  f = fcode (tmp);
		}
	      else if (m == ME)
		{
		  /* + */
		  printhan (f, m, l);
		  f = FE;
		  m = ME;
		  l = LE;
		  ll = LE;
		  continue;
		}
	      else if (l == LE)
		{
		  /*  ˻ */
		  l = lcode (f, m, tmp);
		  if (l == LE)
		    {
		      /* +->ʼ+߼ */
		      printhan (f, m, l);
		      f = FE;
		      m = ME;
		      l = LE;
		      ll = LE;
		      continue;
		    }
		}
	      else if (ll == LE)
		{
		  /* () ˻ */
		  ll = llcode (f, m, l, tmp);
		  if (ll == LE)
		    {
		      /* ++->ʼ+߼+ */
		      printhan (f, m, l);
		      f = FE;
		      m = ME;
		      l = LE;
		      ll = LE;
		      continue;
		    }
		  else		/*  ι°  */
		    ltmp = tmp;
		}
	      else
		{
		  /* ++->ʼ+߼+ */
		  printhan (f, m, ll);
		  f = FE;
		  m = ME;
		  l = LE;
		  ll = LE;
		  continue;
		}
	      break;
	    case MO:		/*  */
	      if (ll != LE)
		{
		  /*  и */
		  printhan (f, m, l);
		  f = fcode (ltmp);
		  m = ME;
		  l = LE;
		  ll = LE;
		}
	      else if (l != LE)
		{
		  /* ->  ʼ */
		  printhan (f, m, LE);
		  f = fcode (lrev (l));
		  m = ME;
		  l = LE;
		  ll = LE;
		}
	      if (m == ME)
		{
		  if (tmp == 'J' || tmp == 'K' || tmp == 'L')
		    {
		      f = FE;
		      m = mcode (tmp - 'A' + 'a');
		      l = LE;
		      printhan (f, m, l);
		      m = ME;
		      break;
		    }
		  else
		    m = mcode (tmp);
		}
	      else
		{
		  /* (߼) ˻ */
		  mm = mmcode (m, tmp);
		  if (mm == ME)
		    {
		      /* +->ʼ+߼ */
		      printhan (f, m, l);
		      f = FE;
		      m = ME;
		      l = LE;
		      ll = LE;
		      continue;
		    }
		  else
		    /* ->߼ */
		    m = mm;
		}
	      break;
	    default:		/* ѱ ƴҶ */
	      if (f != FE || m != ME || l != LE || ll != LE)
		{
		  /*  ѱ  */
		  printhan (f, m, (ll == LE ? l : ll));
		  f = FE;
		  m = ME;
		  l = LE;
		  ll = LE;
		}
	      /* et  Ǻ */
	      if (tmp == end)
		{
		  if (delimiter)
		    printf ("%c", rend);
		  et = ENG;
		}
	      else
		printf ("%c", tmp);
	    }
	  break;
	case KTE:
	  if (!(tmp & 0x80))
	    {			/* ѱ ƴϸ */
	      if (!text)
		{
		  if (tmp == rend)
		    {
		      if (delimiter)
			printf ("%c", end);
		      et = ENG;
		    }
		  else
		    printf ("%c", tmp);
		}
	      else
		{
		  if (tmp != ' ' && text == 2)
		    {
		      text = 1;
		      printf ("%c", end);
		    }
		  printf ("%c", tmp);
		}
	      break;
	    }			/* ѱ̸ */
	  if (text == 1)
	    {
	      text = 2;
	      printf ("%s", begin);
	    }
	  d[0] = tmp;
	  if ((d[1] = getchar ()) == rend)
	    {
	      if (!text)
		{
		  printf ("%c", tmp);
		  if (delimiter)
		    printf ("%c", end);
		  et = ENG;
		  break;
		}
	    }
	  if (johab)
	    convert_johab_to_3 (d, &f, &m, &l);
	  else
	    convert_ks_to_3 (d, &f, &m, &l);
	  prtf (f);

/**ذ**************************************************/
/*  Ȧ  : <=>̤,<=>Ǥ,<=>Ǥ */
/*                          nj   nJ  ,hk   hK  ,hl   hL   */
/* , <=>Ǥ,<=>̤Ĵ   .                  */
/*     ho   hO  ,np   nP: O , P   ҴǾ  */
/*     Ǥ=>,̤=>η   ȯ                   */
/**********************************************************/
	  if (f == FE && l == LE)
	    if (mrev (m) == 'j' || mrev (m) == 'k' || mrev (m) == 'l')
	      {
		printf ("%c", mrev (m) - 'a' + 'A');
		break;
	      }
	  prtm (m);
	  prtl (l);
	  f = FE;
	  m = ME;
	  l = LE;
	  break;
	default:		/*   */
	  printf ("%c", tmp);
	  break;
	}
      /*  б */
      tmp = getchar ();
    }

  /* EOF      */
  if (et)
    {
      if (f != FE || m != ME || l != LE || ll != LE)
	{
	  printhan (f, m, (ll == LE ? l : ll));
	}
    }
  else if (tmp != EOF)
    printf ("%c", tmp);
  exit (0);
}
